;---------------------------------------------------------------------
actions_for_all:
;;        DEBUGF  1, "actions_for_all\n"
	; set start coordinates
	mov	ebx,LEVEL_MAP_SIZE_Y
	mov	ecx,plan_level+(LEVEL_MAP_SIZE_Y*LEVEL_MAP_SIZE_X*4)-4
;--------------------------------------
.new_y:
	mov	eax,LEVEL_MAP_SIZE_X
;--------------------------------------
.new_x:
	push	eax ebx ecx

	mov	edx,[ecx]
	mov	ebp,ecx
	sub	ebp,plan_level
;        DEBUGF  1, "Y : %x X: %x cell: %x ebp: %x\n",ebx,eax,edx,ebp
	ror	edx,16
	test	dh,dh
	jnz	.end_processing_sell

	test	dl,dl
	jz	.end_processing_sell

	call	processing_NPC_route
;        DEBUGF  1, "new cell: %x\n",edx
;--------------------------------------	
.end_processing_sell:
	pop	ecx ebx eax
	
	sub	ecx,4
	dec	eax
	jnz	.new_x
	
	dec	ebx
	jnz	.new_y
;;        DEBUGF  1, "actions_for_all END\n"
	ret
;---------------------------------------------------------------------
processing_NPC_route:
;;        DEBUGF  1, "processing_NPC_route\n"
	cmp	dl,ROUTE_UP
	je	route_up

	cmp	dl,ROUTE_DOWN
	je	route_down

	cmp	dl,ROUTE_LEFT
	je	route_left

	cmp	dl,ROUTE_RIGHT
	je	route_right

	ret
;---------------------------------------------------------------------
route_up:
;        DEBUGF  1, "route_up\n"
	cmp	ebx,1
	jne	@f

;--------------------------------------
.change_route:
;        DEBUGF  1, ".change_route_up\n"
	mov	dx,0x0100+ROUTE_DOWN
	rol	edx,16
	mov	[ecx],edx
	ret
;--------------------------------------
@@:
;        DEBUGF  1, "up @@:\n"
	mov	eax,[ecx-LEVEL_MAP_SIZE_X*4]
	test	ah,ah
	jnz	.change_route
	
	ror	eax,16
;        DEBUGF  1, "good route up\n"
	mov	ax,0x0100+ROUTE_UP
	rol	eax,16
	rol	edx,16
	mov	ah,dh
	mov	[ecx-LEVEL_MAP_SIZE_X*4],eax ; new cell for unit
	and	edx,0xff
	add	edx,0x01000000
	mov	[ecx],edx ; clear old cell
	ret
;---------------------------------------------------------------------
route_down:
;        DEBUGF  1, "route_down\n"
	cmp	ebx,LEVEL_MAP_SIZE_Y
	jne	@f

;--------------------------------------
.change_route:
;        DEBUGF  1, ".change_route_down\n"
	mov	dx,0x0100+ROUTE_UP
	rol	edx,16
	mov	[ecx],edx
	ret
;--------------------------------------
@@:
;        DEBUGF  1, "down @@:\n"
	mov	eax,[ecx+LEVEL_MAP_SIZE_X*4]
	test	ah,ah
	jnz	.change_route
	
	ror	eax,16
;        DEBUGF  1, "good route down\n"
	mov	ax,0x0100+ROUTE_DOWN
	rol	eax,16
	rol	edx,16
	mov	ah,dh
	mov	[ecx+LEVEL_MAP_SIZE_X*4],eax ; new cell for unit
	and	edx,0xff
	add	edx,0x01000000
	mov	[ecx],edx ; clear old cell
	ret
;--------------------------------------
route_left:
;        DEBUGF  1, "route_left\n"
	cmp	eax,1
	jne	@f

;--------------------------------------
.change_route:
;        DEBUGF  1, ".change_route_left\n"
	mov	dx,0x0100+ROUTE_RIGHT
	rol	edx,16
	mov	[ecx],edx
	ret
;--------------------------------------
@@:
;        DEBUGF  1, "left @@:\n"
	mov	eax,[ecx-4]
	test	ah,ah
	jnz	.change_route
	
	ror	eax,16
;        DEBUGF  1, "good route left\n"
	mov	ax,0x0100+ROUTE_LEFT
	rol	eax,16
	rol	edx,16
	mov	ah,dh
	mov	[ecx-4],eax ; new cell for unit
	and	edx,0xff
	add	edx,0x01000000
	mov	[ecx],edx ; clear old cell
	ret
;--------------------------------------
route_right:
;        DEBUGF  1, "route_right\n"
	cmp	eax,LEVEL_MAP_SIZE_X
	jne	@f

;--------------------------------------
.change_route:
;        DEBUGF  1, ".change_route_right\n"
	mov	dx,0x0100+ROUTE_LEFT
	rol	edx,16
	mov	[ecx],edx
	ret
;--------------------------------------
@@:
;        DEBUGF  1, "righ @@:\n"
	mov	eax,[ecx+4]
	test	ah,ah
	jnz	.change_route

	ror	eax,16
;        DEBUGF  1, "good route righ\n"
	mov	ax,0x0100+ROUTE_RIGHT
	rol	eax,16
	rol	edx,16
	mov	ah,dh
	mov	[ecx+4],eax ; new cell for unit
	and	edx,0xff
	add	edx,0x01000000
	mov	[ecx],edx ; clear old cell
	ret
;--------------------------------------
